#include <konkret/konkret.h>
#include "Linux_AccountManagementServiceCapabilities.h"
#include "Linux_AccountManagementService.h"
#include "Linux_AccountManagementCapabilities.h"

#include "globals.h"

static const CMPIBroker* _cb;

static void Linux_AccountManagementServiceCapabilitiesInitialize()
{
}

static CMPIStatus Linux_AccountManagementServiceCapabilitiesCleanup( 
    CMPIInstanceMI* mi,
    const CMPIContext* cc, 
    CMPIBoolean term)
{
    CMReturn(CMPI_RC_OK);
}

static CMPIStatus Linux_AccountManagementServiceCapabilitiesEnumInstanceNames( 
    CMPIInstanceMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop)
{
    return KDefaultEnumerateInstanceNames(
        _cb, mi, cc, cr, cop);
}

static CMPIStatus Linux_AccountManagementServiceCapabilitiesEnumInstances( 
    CMPIInstanceMI* mi,
    const CMPIContext* cc, 
    const CMPIResult* cr, 
    const CMPIObjectPath* cop, 
    const char** properties) 
{
    Linux_AccountManagementServiceRef lamsref;
    Linux_AccountManagementCapabilitiesRef lamcref;
    Linux_AccountManagementServiceCapabilities lamsc;

    const char *nameSpace = KNameSpace(cop);
    const char *hostname = get_system_name();

    Linux_AccountManagementServiceRef_Init(&lamsref, _cb, nameSpace);
    Linux_AccountManagementServiceRef_Set_Name(&lamsref, LAMSNAME);
    Linux_AccountManagementServiceRef_Set_SystemCreationClassName(&lamsref,
      SCCLASSNAME);
    Linux_AccountManagementServiceRef_Set_SystemName(&lamsref, hostname);
    Linux_AccountManagementServiceRef_Set_CreationClassName(&lamsref,
      Linux_AccountManagementService_ClassName);

    Linux_AccountManagementCapabilitiesRef_Init(&lamcref, _cb, nameSpace);
    Linux_AccountManagementCapabilitiesRef_Set_InstanceID(&lamcref,
      ORGID":"LAMCNAME);

    Linux_AccountManagementServiceCapabilities_Init(&lamsc, _cb, nameSpace);
    Linux_AccountManagementServiceCapabilities_Set_ManagedElement(&lamsc,
      &lamsref);
    Linux_AccountManagementServiceCapabilities_Set_Capabilities(&lamsc,
      &lamcref);

    KReturnInstance(cr, lamsc);

    CMReturn(CMPI_RC_OK);
}

static CMPIStatus Linux_AccountManagementServiceCapabilitiesGetInstance( 
    CMPIInstanceMI* mi, 
    const CMPIContext* cc,
    const CMPIResult* cr, 
    const CMPIObjectPath* cop, 
    const char** properties) 
{
    return KDefaultGetInstance(
        _cb, mi, cc, cr, cop, properties);
}

static CMPIStatus Linux_AccountManagementServiceCapabilitiesCreateInstance( 
    CMPIInstanceMI* mi, 
    const CMPIContext* cc, 
    const CMPIResult* cr, 
    const CMPIObjectPath* cop, 
    const CMPIInstance* ci) 
{
    CMReturn(CMPI_RC_ERR_NOT_SUPPORTED);
}

static CMPIStatus Linux_AccountManagementServiceCapabilitiesModifyInstance( 
    CMPIInstanceMI* mi, 
    const CMPIContext* cc, 
    const CMPIResult* cr, 
    const CMPIObjectPath* cop,
    const CMPIInstance* ci, 
    const char**properties) 
{
    CMReturn(CMPI_RC_ERR_NOT_SUPPORTED);
}

static CMPIStatus Linux_AccountManagementServiceCapabilitiesDeleteInstance( 
    CMPIInstanceMI* mi, 
    const CMPIContext* cc, 
    const CMPIResult* cr, 
    const CMPIObjectPath* cop) 
{
    CMReturn(CMPI_RC_ERR_NOT_SUPPORTED);
}

static CMPIStatus Linux_AccountManagementServiceCapabilitiesExecQuery(
    CMPIInstanceMI* mi, 
    const CMPIContext* cc, 
    const CMPIResult* cr, 
    const CMPIObjectPath* cop, 
    const char* lang, 
    const char* query) 
{
    CMReturn(CMPI_RC_ERR_NOT_SUPPORTED);
}

static CMPIStatus Linux_AccountManagementServiceCapabilitiesAssociationCleanup( 
    CMPIAssociationMI* mi,
    const CMPIContext* cc, 
    CMPIBoolean term) 
{
    CMReturn(CMPI_RC_OK);
}

static CMPIStatus Linux_AccountManagementServiceCapabilitiesAssociators(
    CMPIAssociationMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop,
    const char* assocClass,
    const char* resultClass,
    const char* role,
    const char* resultRole,
    const char** properties)
{
    return KDefaultAssociators(
        _cb,
        mi,
        cc,
        cr,
        cop,
        Linux_AccountManagementServiceCapabilities_ClassName,
        assocClass,
        resultClass,
        role,
        resultRole,
        properties);
}

static CMPIStatus Linux_AccountManagementServiceCapabilitiesAssociatorNames(
    CMPIAssociationMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop,
    const char* assocClass,
    const char* resultClass,
    const char* role,
    const char* resultRole)
{
    return KDefaultAssociatorNames(
        _cb,
        mi,
        cc,
        cr,
        cop,
        Linux_AccountManagementServiceCapabilities_ClassName,
        assocClass,
        resultClass,
        role,
        resultRole);
}

static CMPIStatus Linux_AccountManagementServiceCapabilitiesReferences(
    CMPIAssociationMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop,
    const char* assocClass,
    const char* role,
    const char** properties)
{
    return KDefaultReferences(
        _cb,
        mi,
        cc,
        cr,
        cop,
        Linux_AccountManagementServiceCapabilities_ClassName,
        assocClass,
        role,
        properties);
}

static CMPIStatus Linux_AccountManagementServiceCapabilitiesReferenceNames(
    CMPIAssociationMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop,
    const char* assocClass,
    const char* role)
{
    return KDefaultReferenceNames(
        _cb,
        mi,
        cc,
        cr,
        cop,
        Linux_AccountManagementServiceCapabilities_ClassName,
        assocClass,
        role);
}

CMInstanceMIStub( 
    Linux_AccountManagementServiceCapabilities,
    Linux_AccountManagementServiceCapabilities,
    _cb,
    Linux_AccountManagementServiceCapabilitiesInitialize())

CMAssociationMIStub( 
    Linux_AccountManagementServiceCapabilities,
    Linux_AccountManagementServiceCapabilities,
    _cb,
    Linux_AccountManagementServiceCapabilitiesInitialize())

KONKRET_REGISTRATION(
    "root/cimv2",
    "Linux_AccountManagementServiceCapabilities",
    "Linux_AccountManagementServiceCapabilities",
    "instance association");
