#include <konkret/konkret.h>
#include "Linux_EnabledAccountCapabilities.h"

#include "globals.h"

#include <stdbool.h>

static const CMPIBroker* _cb = NULL;

static void Linux_EnabledAccountCapabilitiesInitialize()
{
}

static CMPIStatus Linux_EnabledAccountCapabilitiesCleanup(
    CMPIInstanceMI* mi,
    const CMPIContext* cc,
    CMPIBoolean term)
{
    CMReturn(CMPI_RC_OK);
}

static CMPIStatus Linux_EnabledAccountCapabilitiesEnumInstanceNames(
    CMPIInstanceMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop)
{
    return KDefaultEnumerateInstanceNames(
        _cb, mi, cc, cr, cop);
}

static CMPIStatus Linux_EnabledAccountCapabilitiesEnumInstances(
    CMPIInstanceMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop,
    const char** properties)
{
    Linux_EnabledAccountCapabilities leac;

    const char *nameSpace = KNameSpace(cop);
    const char *hostname = get_system_name();

    Linux_EnabledAccountCapabilities_Init(&leac, _cb, nameSpace);
    Linux_EnabledAccountCapabilities_Set_InstanceID(&leac, ORGID":"LEACNAME);
    Linux_EnabledAccountCapabilities_Set_ElementName(&leac, LEACNAME);
    Linux_EnabledAccountCapabilities_Init_RequestedStatesSupported(&leac, 0);
    Linux_EnabledAccountCapabilities_Set_ElementNameEditSupported(&leac,
      false);

    KReturnInstance(cr, leac);

    CMReturn(CMPI_RC_OK);
}

static CMPIStatus Linux_EnabledAccountCapabilitiesGetInstance(
    CMPIInstanceMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop,
    const char** properties)
{
    return KDefaultGetInstance(
        _cb, mi, cc, cr, cop, properties);
}

static CMPIStatus Linux_EnabledAccountCapabilitiesCreateInstance(
    CMPIInstanceMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop,
    const CMPIInstance* ci)
{
    CMReturn(CMPI_RC_ERR_NOT_SUPPORTED);
}

static CMPIStatus Linux_EnabledAccountCapabilitiesModifyInstance(
    CMPIInstanceMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop,
    const CMPIInstance* ci,
    const char** properties)
{
    CMReturn(CMPI_RC_ERR_NOT_SUPPORTED);
}

static CMPIStatus Linux_EnabledAccountCapabilitiesDeleteInstance(
    CMPIInstanceMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop)
{
    CMReturn(CMPI_RC_ERR_NOT_SUPPORTED);
}

static CMPIStatus Linux_EnabledAccountCapabilitiesExecQuery(
    CMPIInstanceMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop,
    const char* lang,
    const char* query)
{
    CMReturn(CMPI_RC_ERR_NOT_SUPPORTED);
}

CMInstanceMIStub(
    Linux_EnabledAccountCapabilities,
    Linux_EnabledAccountCapabilities,
    _cb,
    Linux_EnabledAccountCapabilitiesInitialize())

static CMPIStatus Linux_EnabledAccountCapabilitiesMethodCleanup(
    CMPIMethodMI* mi,
    const CMPIContext* cc,
    CMPIBoolean term)
{
    CMReturn(CMPI_RC_OK);
}

static CMPIStatus Linux_EnabledAccountCapabilitiesInvokeMethod(
    CMPIMethodMI* mi,
    const CMPIContext* cc,
    const CMPIResult* cr,
    const CMPIObjectPath* cop,
    const char* meth,
    const CMPIArgs* in,
    CMPIArgs* out)
{
    return Linux_EnabledAccountCapabilities_DispatchMethod(
        _cb, mi, cc, cr, cop, meth, in, out);
}

CMMethodMIStub(
    Linux_EnabledAccountCapabilities,
    Linux_EnabledAccountCapabilities,
    _cb,
    Linux_EnabledAccountCapabilitiesInitialize())

KONKRET_REGISTRATION(
    "root/cimv2",
    "Linux_EnabledAccountCapabilities",
    "Linux_EnabledAccountCapabilities",
    "instance method");
